(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('ngx-access', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-access'] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.router));
}(this, (function (exports, i0, rxjs, operators, i1) { 'use strict';

    function flatten(config, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.parse, parse = _c === void 0 ? function (v) { return v; } : _c, _d = _b.group, group = _d === void 0 ? false : _d;
        var flatConfig = {};
        function setConfig(path, value) {
            if (!flatConfig[path]) {
                flatConfig[path] = new Set();
            }
            flatConfig[path].add(value);
        }
        function getPath(path, delimiter, prop) {
            return path ? path + delimiter + prop : prop;
        }
        function visitor(accesses, prop, value, path) {
            if (Array.isArray(value)) {
                value.forEach(function (access) {
                    visitor(accesses, prop, access, path);
                });
            }
            else if (typeof value === 'object') {
                var childrenAccesses = children(value, getPath(path, '.', prop));
                if (group) {
                    accesses = accesses.concat(childrenAccesses);
                    accesses.forEach(function (access) {
                        setConfig(getPath(path, ':', access.prop), access.action);
                    });
                }
            }
            else {
                var expression = parse(value.replace(/\s/g, ''));
                setConfig(getPath(path, ':', prop), expression);
                accesses = accesses.concat({ action: expression, prop: prop });
            }
            return accesses;
        }
        function children(obj, path) {
            if (path === void 0) { path = ''; }
            return Object.keys(obj).reduce(function (accesses, prop) { return visitor(accesses, prop, obj[prop], path); }, []);
        }
        children(config);
        return flatConfig;
    }

    var TokenType = {
        PAR_OPEN: '('.charCodeAt(0),
        PAR_CLOSE: ')'.charCodeAt(0),
        OP_NOT: '!'.charCodeAt(0),
        BINARY_AND: '&'.charCodeAt(0),
        BINARY_OR: '|'.charCodeAt(0),
        LITERAL: 'LITERAL',
        END: 'END',
        LEAF: 'LEAF',
        ATOMIC: 'ATOMIC',
    };

    var operator = function (evaluator$, op) { return function (source) {
        return new rxjs.Observable(function (observer) {
            var finish$ = new rxjs.Subject();
            var lastEval;
            finish$.pipe(operators.take(1)).subscribe(function (value) {
                observer.next(value);
                observer.complete();
            }, function (e) { return observer.error(e); });
            source.pipe(operators.switchMap(evaluator$), operators.takeUntil(finish$)).subscribe(function (value) {
                lastEval = op === TokenType.OP_NOT ? !value : value;
                if (op === TokenType.BINARY_AND && !lastEval) {
                    finish$.next(false);
                }
                else if (op === TokenType.BINARY_OR && lastEval) {
                    finish$.next(true);
                }
            }, function (e) {
                finish$.error(e);
            }, function () {
                finish$.next(lastEval);
            });
        });
    }; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var Tokenizer = function (exp) {
        var e_1, _a;
        var literal = '';
        var tokens = [];
        try {
            for (var exp_1 = __values(exp), exp_1_1 = exp_1.next(); !exp_1_1.done; exp_1_1 = exp_1.next()) {
                var char = exp_1_1.value;
                var code = char.charCodeAt(0);
                switch (code) {
                    case TokenType.PAR_OPEN:
                    case TokenType.PAR_CLOSE:
                    case TokenType.OP_NOT:
                    case TokenType.BINARY_AND:
                    case TokenType.BINARY_OR:
                        if (literal) {
                            tokens.push({
                                type: TokenType.LITERAL,
                                value: literal,
                            });
                            literal = '';
                        }
                        tokens.push({
                            type: code,
                            value: char,
                        });
                        break;
                    default:
                        literal += char;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (exp_1_1 && !exp_1_1.done && (_a = exp_1.return)) _a.call(exp_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (literal)
            tokens.push({
                type: TokenType.LITERAL,
                value: literal,
            });
        return tokens;
    };
    var ɵ0 = Tokenizer;

    var PolishNotation = function (tokens) {
        var stack = [];
        var queue = [];
        var subQueue = [];
        var subStack = [];
        tokens.forEach(function (token) {
            switch (token.type) {
                case TokenType.LITERAL:
                case TokenType.OP_NOT:
                    if (subStack.length) {
                        subQueue.push(token);
                    }
                    else {
                        queue.push(token);
                    }
                    break;
                case TokenType.BINARY_AND:
                case TokenType.BINARY_OR:
                    if (subStack.length) {
                        subStack.unshift(token);
                    }
                    else {
                        stack.unshift(token);
                    }
                    break;
                case TokenType.PAR_OPEN:
                    subStack.unshift(token);
                    break;
                case TokenType.PAR_CLOSE:
                    while (subStack.length &&
                        subStack[subStack.length - 1].type !== TokenType.PAR_OPEN) {
                        subQueue.unshift(subStack.pop());
                    }
                    subStack.pop();
                    if (subStack.length &&
                        subStack[subStack.length - 1].type === TokenType.OP_NOT) {
                        subQueue.unshift(subStack.pop());
                    }
                    queue = queue.concat(__spread(subStack, subQueue));
                    subStack = [];
                    subQueue = [];
                    break;
                default:
                    break;
            }
        });
        var result = (stack.length && __spread(stack, queue)) || queue;
        return result;
    };
    var ɵ0$1 = PolishNotation;
    var PolishGenerator = function (polish) {
        var index;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    index = 0;
                    _a.label = 1;
                case 1:
                    if (!(index < polish.length - 1)) return [3 /*break*/, 4];
                    return [4 /*yield*/, polish[index]];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    index++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, polish[polish.length - 1]];
            }
        });
    };
    var ɵ1 = PolishGenerator;

    var ExpNode = /** @class */ (function () {
        function ExpNode(op, left, right, literal) {
            this.op = op;
            this.left = left;
            this.right = right;
            this.literal = literal;
        }
        ExpNode.prototype.isLeaf = function () {
            return this.op === TokenType.LEAF;
        };
        ExpNode.prototype.isAtomic = function () {
            var _a;
            return (this.isLeaf() || (this.op === TokenType.OP_NOT && ((_a = this.left) === null || _a === void 0 ? void 0 : _a.isLeaf())));
        };
        ExpNode.prototype.getLiteralValue = function () {
            return this.literal || '';
        };
        ExpNode.CreateAnd = function (left, right) {
            return new ExpNode(TokenType.BINARY_AND, left, right);
        };
        ExpNode.CreateNot = function (exp) {
            return new ExpNode(TokenType.OP_NOT, exp);
        };
        ExpNode.CreateOr = function (left, right) {
            return new ExpNode(TokenType.BINARY_OR, left, right);
        };
        ExpNode.CreateLiteral = function (lit) {
            return new ExpNode(TokenType.LEAF, null, null, lit);
        };
        return ExpNode;
    }());
    var make = function (gen) {
        var data = gen.next().value;
        switch (data.type) {
            case TokenType.LITERAL:
                return ExpNode.CreateLiteral(data.value);
            case TokenType.OP_NOT:
                return ExpNode.CreateNot(make(gen));
            case TokenType.BINARY_AND: {
                var left = make(gen);
                var right = make(gen);
                return ExpNode.CreateAnd(left, right);
            }
            case TokenType.BINARY_OR: {
                var left = make(gen);
                var right = make(gen);
                return ExpNode.CreateOr(left, right);
            }
        }
        return null;
    };
    var nodeEvaluator = function (tree, literalEvaluator) {
        if (tree) {
            if (tree.isLeaf()) {
                return literalEvaluator(tree.getLiteralValue());
            }
            if (tree.op === TokenType.OP_NOT) {
                return !nodeEvaluator(tree.left, literalEvaluator);
            }
            if (tree.op === TokenType.BINARY_OR) {
                return (nodeEvaluator(tree.left, literalEvaluator) ||
                    nodeEvaluator(tree.right, literalEvaluator));
            }
            if (tree.op === TokenType.BINARY_AND) {
                return (nodeEvaluator(tree.left, literalEvaluator) &&
                    nodeEvaluator(tree.right, literalEvaluator));
            }
        }
        return false;
    };

    var parser = function (exp) {
        var tokens = Tokenizer(exp.replace(/\s/g, ''));
        var polish = PolishNotation(tokens);
        var gen = PolishGenerator(polish);
        var tree = make(gen);
        return tree;
    };
    var ɵ0$2 = parser;

    var configurationAccess = {};
    var hasAccessStrategy = function (accessName) { return rxjs.of(false); };
    var ɵ0$3 = hasAccessStrategy;
    function setConfigurationAccess(config) {
        configurationAccess = flatten(config, { parse: parser, group: true });
    }
    function setHasAccessStrategy(accessTest) {
        hasAccessStrategy = accessTest;
    }
    function parse(expression) {
        var arr = expression.replace(/\s/g, '').split(':');
        return {
            path: arr[0] || '',
            action: arr[1] || '',
        };
    }
    function canAccessExpression(accessExpression) {
        return rxjs.of(accessExpression).pipe(operators.map(function (ae) { return ae.replace(/\s/g, ''); }), operators.switchMap(function (ae) { return nodeEvaluator$1(parser(ae), hasAccessStrategy); }));
    }
    function canAccessPaths(accessPath) {
        var access = Array.isArray(accessPath)
            ? accessPath
            : [accessPath];
        return rxjs.from(access).pipe(operators.map(function (ap) { return ap.replace(/\s/g, ''); }), operator(canAccessPath, TokenType.BINARY_OR));
    }
    function canAccessPath(path) {
        try {
            var access = configurationAccess[path];
            if (!!access) {
                return rxjs.from(access).pipe(operator(function (tree) { return nodeEvaluator$1(tree, hasAccessStrategy); }, TokenType.BINARY_OR));
            }
            console.error("Undefined path " + path);
            return rxjs.of(false);
        }
        catch (e) {
            console.error(e);
            return rxjs.of(false);
        }
    }
    function nodeEvaluator$1(tree, literalEvaluator) {
        if (tree) {
            if (tree.isLeaf()) {
                return literalEvaluator(tree.getLiteralValue());
            }
            if (tree.op === TokenType.OP_NOT) {
                return rxjs.of(tree.left).pipe(operator(function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }, TokenType.OP_NOT));
            }
            if (tree.op === TokenType.BINARY_OR) {
                return rxjs.from([tree.left, tree.right]).pipe(operator(function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }, TokenType.BINARY_OR));
            }
            if (tree.op === TokenType.BINARY_AND) {
                return rxjs.from([tree.left, tree.right]).pipe(operator(function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }, TokenType.BINARY_AND));
            }
        }
        return rxjs.of(false);
    }

    var ACCESS_CONFIG = new i0.InjectionToken('ACCESS_CONFIG');

    var AccessStrategy = /** @class */ (function () {
        function AccessStrategy() {
        }
        return AccessStrategy;
    }());
    var FakeAccessStrategy = /** @class */ (function (_super) {
        __extends(FakeAccessStrategy, _super);
        function FakeAccessStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FakeAccessStrategy.prototype.has = function (access) {
            return rxjs.of(false);
        };
        return FakeAccessStrategy;
    }(AccessStrategy));
    FakeAccessStrategy.decorators = [
        { type: i0.Injectable }
    ];

    var AccessService = /** @class */ (function () {
        function AccessService(config, accessStrategy) {
            setHasAccessStrategy(function (accessName) { return accessStrategy.has(accessName); });
            setConfigurationAccess(config.accesses || {});
        }
        AccessService.prototype.can = function (accessPaths) {
            return canAccessPaths(accessPaths);
        };
        AccessService.prototype.canExpression = function (accessExpression) {
            return canAccessExpression(accessExpression);
        };
        return AccessService;
    }());
    AccessService.ɵprov = i0.ɵɵdefineInjectable({ factory: function AccessService_Factory() { return new AccessService(i0.ɵɵinject(ACCESS_CONFIG), i0.ɵɵinject(AccessStrategy)); }, token: AccessService, providedIn: "root" });
    AccessService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    AccessService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] },
        { type: AccessStrategy }
    ]; };

    var AccessDirective = /** @class */ (function () {
        function AccessDirective(template, viewContainer, accessService, parentAccessDirective) {
            this.template = template;
            this.viewContainer = viewContainer;
            this.accessService = accessService;
            this.parentAccessDirective = parentAccessDirective;
            this.ngxAccess = '';
            this.onDestroy$ = new rxjs.Subject();
        }
        AccessDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (this.template) {
                var ngxAccess = this.ngxAccess;
                if (this.parentAccessDirective) {
                    var _a = parse(this.parentAccessDirective.ngxAccess), path_1 = _a.path, action = _a.action;
                    if (this.ngxAccess) {
                        if (Array.isArray(this.ngxAccess)) {
                            ngxAccess = this.ngxAccess.map(function (access) { return access.replace('$', path_1); }) + ":" + action;
                        }
                        else {
                            var _b = parse(ngxAccess), childPath = _b.path, childAction = _b.action;
                            ngxAccess = childPath.replace('$', path_1) + ":" + (childAction ? childAction : action);
                        }
                    }
                    else {
                        ngxAccess = path_1 + ":" + action;
                    }
                }
                this.accessService
                    .can(ngxAccess)
                    .pipe(operators.takeUntil(this.onDestroy$))
                    .subscribe(function (access) { return access
                    ? _this.viewContainer.createEmbeddedView(_this.template)
                    : _this.ngxAccessElse
                        ? _this.viewContainer.createEmbeddedView(_this.ngxAccessElse)
                        : null; });
            }
        };
        AccessDirective.prototype.ngOnDestroy = function () {
            this.onDestroy$.next();
            this.onDestroy$.complete();
        };
        return AccessDirective;
    }());
    AccessDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngxAccess]',
                },] }
    ];
    AccessDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef, decorators: [{ type: i0.Optional }] },
        { type: i0.ViewContainerRef },
        { type: AccessService },
        { type: AccessDirective, decorators: [{ type: i0.Optional }, { type: i0.SkipSelf }, { type: i0.Host }] }
    ]; };
    AccessDirective.propDecorators = {
        ngxAccess: [{ type: i0.Input }],
        ngxAccessElse: [{ type: i0.Input }]
    };

    var AccessExpressionDirective = /** @class */ (function () {
        function AccessExpressionDirective(template, viewContainer, accessService) {
            this.template = template;
            this.viewContainer = viewContainer;
            this.accessService = accessService;
            this.ngxAccessExpr = '';
            this.onDestroy$ = new rxjs.Subject();
        }
        AccessExpressionDirective.prototype.ngOnInit = function () {
            var _this = this;
            if (this.template) {
                this.accessService
                    .canExpression(this.ngxAccessExpr)
                    .pipe(operators.takeUntil(this.onDestroy$))
                    .subscribe(function (access) { return access
                    ? _this.viewContainer.createEmbeddedView(_this.template)
                    : _this.ngxAccessExprElse
                        ? _this.viewContainer.createEmbeddedView(_this.ngxAccessExprElse)
                        : null; });
            }
        };
        AccessExpressionDirective.prototype.ngOnDestroy = function () {
            this.onDestroy$.next();
            this.onDestroy$.complete();
        };
        return AccessExpressionDirective;
    }());
    AccessExpressionDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[ngxAccessExpr]',
                },] }
    ];
    AccessExpressionDirective.ctorParameters = function () { return [
        { type: i0.TemplateRef },
        { type: i0.ViewContainerRef },
        { type: AccessService }
    ]; };
    AccessExpressionDirective.propDecorators = {
        ngxAccessExpr: [{ type: i0.Input }],
        ngxAccessExprElse: [{ type: i0.Input }]
    };

    var AccessGuard = /** @class */ (function () {
        function AccessGuard(router, accessService, config) {
            this.router = router;
            this.accessService = accessService;
            this.config = config;
        }
        AccessGuard.prototype.canActivate = function (next) {
            var _this = this;
            return this.accessService
                .can(next.data.accesses)
                .pipe(operators.tap(function (hasAccess) { return !hasAccess &&
                _this.router.navigate([next.data.redirect || _this.config.redirect]); }));
        };
        return AccessGuard;
    }());
    AccessGuard.ɵprov = i0.ɵɵdefineInjectable({ factory: function AccessGuard_Factory() { return new AccessGuard(i0.ɵɵinject(i1.Router), i0.ɵɵinject(AccessService), i0.ɵɵinject(ACCESS_CONFIG)); }, token: AccessGuard, providedIn: "root" });
    AccessGuard.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    AccessGuard.ctorParameters = function () { return [
        { type: i1.Router },
        { type: AccessService },
        { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] }
    ]; };

    var AccessModule = /** @class */ (function () {
        function AccessModule() {
        }
        AccessModule.forRoot = function (config) {
            return {
                ngModule: AccessModule,
                providers: [
                    {
                        provide: ACCESS_CONFIG,
                        useValue: {
                            accesses: config.accesses || {},
                            redirect: config.redirect || '/unauthorized',
                        },
                    },
                    config.strategy || {
                        provide: AccessStrategy,
                        useClass: FakeAccessStrategy,
                    },
                ],
            };
        };
        return AccessModule;
    }());
    AccessModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [AccessDirective, AccessExpressionDirective],
                    exports: [AccessDirective, AccessExpressionDirective],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ACCESS_CONFIG = ACCESS_CONFIG;
    exports.AccessDirective = AccessDirective;
    exports.AccessExpressionDirective = AccessExpressionDirective;
    exports.AccessGuard = AccessGuard;
    exports.AccessModule = AccessModule;
    exports.AccessService = AccessService;
    exports.AccessStrategy = AccessStrategy;
    exports.FakeAccessStrategy = FakeAccessStrategy;
    exports.ɵa = AccessDirective;
    exports.ɵb = AccessService;
    exports.ɵc = AccessStrategy;
    exports.ɵd = FakeAccessStrategy;
    exports.ɵe = AccessExpressionDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-access.umd.js.map
