import { Token, TokenItem } from './token-type';
export declare class ExpNode {
    op: TokenItem;
    left: ExpNode | null;
    right?: ExpNode | null | undefined;
    literal?: string | undefined;
    constructor(op: TokenItem, left: ExpNode | null, right?: ExpNode | null | undefined, literal?: string | undefined);
    isLeaf(): boolean;
    isAtomic(): boolean | undefined;
    getLiteralValue(): string;
    static CreateAnd(left: ExpNode | null, right: ExpNode | null): ExpNode;
    static CreateNot(exp: ExpNode | null): ExpNode;
    static CreateOr(left: ExpNode | null, right: ExpNode | null): ExpNode;
    static CreateLiteral(lit: string): ExpNode;
}
export declare const make: (gen: Generator<Token>) => ExpNode | null;
export declare type NodeEvaluator = (tree: ExpNode | null | undefined, literalEvaluator: LiteralEvaluator) => boolean;
export declare type LiteralEvaluator = (tokenItem?: TokenItem) => boolean;
export declare const nodeEvaluator: NodeEvaluator;
